; < FireWall>
align 4

proc_thread_info:

;	INPUT
;	eax=function number (73)
;	ebx=subfunction number (0 .. 4)
;	ecx=thread slot number (-1 for current slot)
;	edx=bufer length ( * if used; only <lengh date are placed in bufer)
;	esi=pointer to bufer ( * if is used)

;  ALL RETURN:
;	eax([esp+32])=ok/error code (0  - ok; -1 - invalid parameters; 
;		1 - slot is empty)
	mov ebp, esp ; 
pti_ebx_switch:
	; in future there will be a lot of subfunctions
	; subfunction region check (0 .. 4):
	xor eax, eax
	cmp ebx, eax
	jl pti_wrongop
	add al, 4
	cmp ebx,eax
	jg pti_wrongop
    cmp  ecx,-1         ; who am I ?
    jne  @f
    mov  ecx,[CURRENT_TASK]
@@:
    cmp ecx, max_processes
    ja  pti_wrongop ; slot number is wrong
    ; shoulf check if no empty slot 
    mov [pti_save_ecx], ecx
    shl     ecx, 5
    mov eax, dword [ecx+CURRENT_TASK+TASKDATA.state]
    cmp	al, 9
    je   pti_empty_slot	
	; switch(pti_ftab::ebx)
	mov eax, ebx
	jmp    dword [pti_ftab + eax * 4]
	
	; wrong parameters
pti_wrongop:
	mov eax,-1
	mov [esp+32], eax
	ret
	; empty slot
pti_empty_slot:
	mov eax, 1
	mov [esp+32], eax
	ret	
	; parameters are ok
pti_return_ok:
	xor eax, eax
	mov [esp+32], eax
	ret

pti_save_ecx:
	dd 0
	dd 0

pti_ftab:
	dd pti_0 ; main process info
	dd pti_1 ; main thread info	
	dd pti_2 ; main thread window info
	dd pti_3 ; main thread window client area info
	dd pti_4 ; additional thread and window stack info
	dd 0

; main process info
; RETURN:
;	date bufer = process 12 character name [+10]
;	ebx = process addres in memory [+22](now always 0, but in future 
;		process base addres may be different for priveleged proceses)
;	ecx = (<used memory>-1) [+26]
;	edx = process PID (now the same PID/TID, as thread TID; 
;		but in future will be PID != TID) [+30]
pti_0:
	lea eax, [ecx*8+SLOT_BASE+APPDATA.app_name]
	mov edi, esi ; edi <- destination bufer
	mov esi, eax ; esi <- source :: process name
	push ecx ; save ecx :: slot number
	mov ecx, edx ; ecx <- date length
	cmp ecx, 11
	ja	@f
	mov ecx, 11
@@:
	cld
	rep movsb 
	pop ecx ; restore ecx :: slot number
	
	xor eax, eax
	mov edx, 0x100000*16
	cmp ecx, 1 shl 5
	je  @f
	mov edx, [SLOT_BASE+ecx*8+APPDATA.mem_size]
	mov eax, std_application_base_address
@@:
	mov [ebp + 20], eax
	dec edx
	mov [ebp + 28], edx 
	mov eax, [ecx+CURRENT_TASK+TASKDATA.pid]
	mov [ebp + 24], eax
    jmp pti_return_ok
	

; main thread info
; RETURN:
;	ebx (bx - bl) = thread state [+50] ->([esp+20])
;	ecx = thread TID (now PID/TID) [+30] ->([esp+28])
;	edx = event mask (as defined in SysFn40) [+71 ?] ->([esp+24])
;	esi = CPU usage [+0] ->([esp+8])
pti_1:
	mov eax, dword [ecx+CURRENT_TASK+TASKDATA.state]
	mov [ebp + 20], eax
	mov eax, [ecx+CURRENT_TASK+TASKDATA.pid]
	mov [ebp + 28], eax
	mov eax, dword [ecx+CURRENT_TASK+TASKDATA.event_mask]
	mov [ebp + 24], eax
	mov eax, [ecx+CURRENT_TASK+TASKDATA.cpu_usage]
	mov [ebp + 8], eax
	; ok ! should return
	jmp pti_return_ok

; main thread window info
; RETURN:
;	ebx = X [+34]->([esp+20])
;	ecx = Y [+38]->([esp+28])
;	edx = W [+42]->([esp+24])
; 	esi = H [+46]->([esp+8])
pti_2:
	;mov ecx, [pti_save_ecx]
	cld
	lea esi, [ecx + window_data + WDATA.box]
	lodsd
	mov [ebp + 20], eax
	lodsd
	mov [ebp + 28], eax
	lodsd
	mov [ebp + 24], eax
	lodsd
	mov [ebp + 8], eax
	; ok ! should return
	jmp pti_return_ok

; main thread window client area info
; RETURN:
;	ebx = X [+54]->([esp+20])
;	ecx = Y [+58]->([esp+28])
;	edx = W [+62]->([esp+24])
; 	esi = H [+66]->([esp+8])
pti_3:
	cld
	lea esi, [ecx*8 + SLOT_BASE + APPDATA.wnd_clientbox]
	lodsd
	mov [ebp + 20], eax
	lodsd
	mov [ebp + 28], eax
	lodsd
	mov [ebp + 24], eax
	lodsd
	mov [ebp + 8], eax
	; ok ! should return
	jmp pti_return_ok

; additional thread and window stack info
; RETURN:
;	ebx (bx)= thread window position in windows stack_driver_stat 
;		[+4]->([esp+20])
;	ecx (cx - cl) = thread window state 
;		[+70]->([esp+28])
;	edx = thread slot number in a especial state (ecx-state?) 
;		[+6]->([esp+24])
;	esi = maximal slot number ( != <number of running thread> ::
;	may be empty slot in the middle) 
;		(eax)->([esp+8])
pti_4:

	xor eax, eax
	mov al, [ecx+window_data+WDATA.fl_wstate]
	mov [ebp + 28], eax
	xor eax, eax
	mov eax,[TASK_COUNT]
	mov [ebp + 8], eax
	mov ecx, [pti_save_ecx]
	xor eax, eax
	mov ax, [WIN_STACK + ecx * 2]
	mov [ebp + 20], eax
	xor eax, eax
	mov ax, [WIN_POS + ecx * 2]
	mov [ebp + 24], eax
	; ok ! should return
	jmp pti_return_ok

; < /FireWall>
