#include "hsizer.h"

void hsizer_do_layout(struct widget_s *this)
{
	struct hsizer_date *sd = (struct hsizer_date *) this->widget_date;

	struct short_rect cur= {
		this->rel_x + 2 , this->rel_y + 2 , 
		2, 2
		};
	struct widget_s *child = this->child;
	
	while (child != NULL) 
	{
		child->rel_x = cur.x + 2;
		child->rel_y = cur.y + 2;
		child->do_layout(child);
		if (cur.h < child->h) cur.h = child->h;
		cur.x += (child->w + sd->delta); 
		cur.w += (child->w + sd->delta);
		child = child->next;
	} /* while */

	cur.w +=6; cur.w -= sd->delta;	cur.h +=2;
	if (cur.w < sd->min_w) cur.w = sd->min_w;
	if (cur.h < sd->min_h) cur.h = sd->min_h; 
	this->w = cur.w; this->h = cur.h;
	return;	
}

void hsizer_do_redraw(struct widget_s *this)
{
	struct hsizer_date *ld = (struct hsizer_date *) this->widget_date;

	kol_paint_bar(this->rel_x , this->rel_y , this->w , this->h , 
					global_colours.work);
	kos_paint_rectangle	(this->rel_x , this->rel_y , this->w , this->h ,
					global_colours.frames);
		
	do_child_redraw(this->child);

	return;	
}

void hsizer_widget_constructor(struct widget_s *this,
							  struct hsizer_date *ld)
{
	this->rel_x = this->rel_y = 2;
	this->w = ld->min_w; this->h = ld->min_h;
	this->do_layout = &hsizer_do_layout;
	this->do_redraw = &hsizer_do_redraw;
	this->child = this->next = NULL;
	this->widget_date = (void *)ld;
}
